'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.useCss = useCss;

var _react = require('react');

var _scopedComponent = require('./scoped.component.js');

var _styleElementUtils = require('./style-element-utils.js');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function useCss(css, overrideNamespace) {
  var _useState = (0, _react.useState)((0, _styleElementUtils.getCurrentCounter)()),
      _useState2 = _slicedToArray(_useState, 2),
      kremlingId = _useState2[0],
      setKremlingId = _useState2[1];

  var isPostCss = css && css.id && css.styles;
  var namespace = overrideNamespace || isPostCss && css.namespace || _scopedComponent.Scoped.defaultNamespace;
  var kremlingAttrName = isPostCss ? namespace : 'data-' + namespace;

  useStyleElement();

  return _defineProperty({}, kremlingAttrName, String(kremlingId).toString());

  function useStyleElement() {
    (0, _react.useLayoutEffect)(function () {
      var styleElement = isPostCss ? document.head.querySelector('[' + kremlingAttrName + '=\'' + kremlingId + '\']') : _styleElementUtils.styleTags[css];

      if (!styleElement) {
        var newKremlingId = isPostCss ? css.id : (0, _styleElementUtils.incrementCounter)();
        var kremlingSelector = '[' + kremlingAttrName + '=\'' + newKremlingId + '\']';
        var rawCss = isPostCss ? css.styles : css;
        var cssToInsert = isPostCss ? css.styles : (0, _styleElementUtils.transformCss)(css, kremlingSelector);

        styleElement = document.createElement('style');
        styleElement.type = 'text/css';
        styleElement.textContent = cssToInsert;
        styleElement.kremlings = 1;
        styleElement.kremlingAttr = kremlingAttrName;
        styleElement.kremlingValue = newKremlingId;
        document.head.appendChild(styleElement);

        _styleElementUtils.styleTags[rawCss] = styleElement;

        setKremlingId(newKremlingId);

        return function () {
          if (--styleElement.kremlings === 0) {
            document.head.removeChild(styleElement);
            delete _styleElementUtils.styleTags[css];
          }
        };
      }
    }, [css, namespace, kremlingAttrName]);
  }
}
//# sourceMappingURL=use-css.hook.js.map